;; agents.clj

(defn fib [i]
  (if (> i 1)
    (+ (fib (- i 1)) (fib (- i 2)))
    i))

(time (fib 40))

(defn benchmark [n]
  (let [agents (for [i (range n)] (agent i))]
    (println "starting agents...")
    (dorun
      (map #(send-off % fib) agents))
    (println "waiting for all to finish...")
    (apply await agents)
    (println "all done!")
    (println "results: " (map deref agents))))

(time (benchmark 40))

(time (wait-futures 10 (benchmark 40)))
