;; multi-2.clj
;; Dispatch via function

(defmulti greeting
  (fn [locale] (:lang locale)))

(defmethod greeting "Français" [locale]
  "Bonjour!")

(defmethod greeting "English" [locale]
  "Hello!")

(defmethod greeting :default [locale]
  (if (map? locale)
    (println "Sorry I don't know" (:lang locale))
    (println "must supply locale for greeting")))

;; locales
(def fr {:lang "Français"})
(def en {:lang "English"})
(def it {:lang "Italiano"})

;; (greeting fr)
;; (greeting en)
;; (greeting au)
